	.dbfile C:\iccv7arm\MIB81F~1\MicroBolt_I2C_GPIO.c
	AREA	"Cidata", DATA
_I2cSlaveAddress:
	DCB 0
	.dbsym s I2cSlaveAddress _I2cSlaveAddress c
_I2cBufferIndex:
	DCB 0
	.dbsym s I2cBufferIndex _I2cBufferIndex c
_I2cPacketDataSize:
	DCB 0
	.dbsym s I2cPacketDataSize _I2cPacketDataSize c
_I2cPacketType:
	DCB 0
	.dbsym s I2cPacketType _I2cPacketType c
_I2cPacketInProgress:
	DCB 0
	.dbsym s I2cPacketInProgress _I2cPacketInProgress c
	AREA	"C$$code", CODE, READONLY
	EXPORT _main
	.dbfunc e main _main fV
	AREA	"C$$code", CODE, READONLY
	ALIGN 4
; PCA9557portValue -> R6
_main:
	stmfd R13!,{R14}
	.dbline -1
	.dbline 44
; /*
; |------------------------------------------------------------------------------------------
; |------------------------------------------------------------------------------------------
; | File Name			  : MicroBolt_I2C_GPIO.c																					
; | Author			    : Micromint, Inc.						
; | Copyright       : Copyright  2005, Micromint, Inc.																	
; | Creation Date		: 12/30/05																							
; | Version			    : 1.00																																												
; | Spaces per tab	:	2																									
; | Description		  : Main C file																																									 
; | Revision			  :	Initial																																																						
; |------------------------------------------------------------------------------------------
; |------------------------------------------------------------------------------------------
; */
; 
; /*
; |----------------------------------------------------
; |     Includes
; |----------------------------------------------------
; */
; 
; #include <ARM/philips/lpc210x.h>
; #include <arm_macros.h>
; #include "MicroBolt_I2C_GPIO.h"
; 
; static unsigned char I2cSlaveAddress = 0;       // I2C slave address
; static unsigned char I2cBuffer[20];             // I2C application buffer
; static unsigned char I2cBufferIndex = 0;        // Index for I2C buffer
; static unsigned char I2cPacketDataSize = 0;     // Number of data bytes for an I2C packet
; static unsigned char I2cPacketType = 0;         // Read or Write packet type
; static unsigned char I2cPacketInProgress = 0;	  // I2C Packet in progress flag			
; 
; /*
; |------------------------------------------------------------------------------------------
; |     Function        :   main
; |     Inputs          :   None
; |     Outputs         :   None
; |     Purpose         :   Main function for system
; |     Author			    :   Micromint, Inc.
; |------------------------------------------------------------------------------------------
; */
; 
; void main(void)
;   {
	.dbline 45
;   unsigned char PCA9557portValue = 0;
	mov R6,#0
	.dbline 47
; 
;   __DISABLE_INTERRUPT();                        // Disable all interrupts
	mrs R12,cpsr
	orr R12,R12,#0x80
	msr cpsr_c,R12
	
	.dbline 54
; 
; /*
; |-------------------------
; | Config MAM 
; |-------------------------
; */
;   MAM_CR = 0x00;                                // Turn MAM off (default)
	mov R4,#0
	ldr R5,LIT_main+0
	str R4,[R5,#0]
	.dbline 55
;   MAM_TIM = 0x04;                               // Set flash timing to 4 clock cycles
	mov R4,#4
	ldr R5,LIT_main+4
	str R4,[R5,#0]
	.dbline 57
; 
;   MAM_CR = 0x02;                                // Fully enable the Memory Accleration Module
	mov R4,#2
	ldr R5,LIT_main+0
	str R4,[R5,#0]
	.dbline 64
; 
; /*
; |-------------------------
; | Config PLL and CCLK 
; |-------------------------
; */
;   SCB_PLLCFG |= 0x23;				 	   		            // Set to 59 MHz (0x03 is multiply value of 4)
	ldr R4,LIT_main+8
	ldr R5,[R4,#0]
	orr R5,R5,#35
	str R5,[R4,#0]
	.dbline 65
;   SCB_PLLCON |= 0x01;                           // Enable the PLL 
	ldr R4,LIT_main+12
	ldr R5,[R4,#0]
	orr R5,R5,#1
	str R5,[R4,#0]
	.dbline 66
;   SCB_PLLFEED = 0xAA;					   	  	          // Shadow register copy to enable changes
	mov R4,#170
	ldr R5,LIT_main+16
	str R4,[R5,#0]
	.dbline 67
;   SCB_PLLFEED = 0x55;                           // in PLLCON and PLLCFG
	mov R4,#85
	ldr R5,LIT_main+16
	str R4,[R5,#0]
	.dbline 74
; 
; /*
; |-------------------------
; | Config PCLK 
; |-------------------------
; */
;   SCB_VPBDIV = 0;                               // Peripheral clock is 1/4th Processor clock which equals 14.7456 MHz
	mov R4,#0
	ldr R5,LIT_main+20
	str R4,[R5,#0]
	.dbline 81
; 
; /*
; |-------------------------
; | Configure VIC 
; |-------------------------
; */
;   VICVectAddr0 = (unsigned)pll_isr;             // Assign the PLL lock ISR vector address
	ldr R4,LIT_main+24
	ldr R5,LIT_main+28
	str R4,[R5,#0]
	.dbline 82
;   VICVectCntl0 = INTERRUPT_CHANNEL_FOR_PLL;     // Assign the VIC address to the actual interrupt
	mov R4,#44
	ldr R5,LIT_main+32
	str R4,[R5,#0]
	.dbline 83
;   VICIntEnable = INTERRUPT_ENABLE_FOR_PLL;      // Enable the interrupt  
	mov R4,#4096
	ldr R5,LIT_main+36
	str R4,[R5,#0]
	.dbline 85
; 
; 	VICVectAddr1 = (unsigned)I2c_ISR;							// Assign the I2C ISR vector address 
	ldr R4,LIT_main+40
	ldr R5,LIT_main+44
	str R4,[R5,#0]
	.dbline 86
;   VICVectCntl1 = INTERRUPT_CHANNEL_FOR_I2C;     // Assign the VIC address to the actual interrupt
	mov R4,#41
	ldr R5,LIT_main+48
	str R4,[R5,#0]
	.dbline 87
;   VICIntEnable = INTERRUPT_ENABLE_FOR_I2C;      // Enable the interrupt 
	mov R4,#512
	ldr R5,LIT_main+36
	str R4,[R5,#0]
	.dbline 89
; 
;   __ENABLE_INTERRUPT();                         // Enable all interrupts
	mrs R12,cpsr
	bic R12,R12,#0x80
	msr cpsr_c,R12
	
	.dbline 96
; 
; /*
; |-------------------------
; | Config GPIO 
; |-------------------------
; */
;   PCB_PINSEL0=0x00000050;                       // Setup with ICCARM App builder - MicroBolt_I2C_GPIO.bcf (I2C)   
	mov R4,#80
	ldr R5,LIT_main+52
	str R4,[R5,#0]
	.dbline 97
;   PCB_PINSEL1=0x55400000;                       //                                   (Secondary JTAG pins) 
	ldr R4,LIT_main+56
	ldr R5,LIT_main+60
	str R4,[R5,#0]
	.dbline 99
; 
;   GPIO_IODIR |= MICROBOLT_LED;                  // Setup MicroBolt LED as output
	ldr R4,LIT_main+64
	ldr R5,[R4,#0]
	orr R5,R5,#4194304
	str R5,[R4,#0]
	.dbline 101
; 
;   GPIO_IOCLR=0xffffffff;                        // Clear all pins to start with
	mvn R4,#0
	ldr R5,LIT_main+68
	str R4,[R5,#0]
	.dbline 108
; 
; /*
; |-------------------------
; | Config I2C Master
; |-------------------------
; */
;   I2C_I2SCLH = 37;                              // I2C clock is 200 KHz (14.7456 MHz/(SCLH + SCLL))
	mov R4,#37
	ldr R5,LIT_main+72
	str R4,[R5,#0]
	.dbline 109
;   I2C_I2SCLL = 37;
	mov R4,#37
	ldr R5,LIT_main+76
	str R4,[R5,#0]
	.dbline 111
; 
;   I2C_I2CONSET = I2C_ENABLE_BIT;                // Enable the I2C channel
	mov R4,#64
	ldr R5,LIT_main+80
	str R4,[R5,#0]
	.dbline 119
; 
; /*
; |-----------------------------------------
; | Config I2C PCA9557 Slave device I/O port
; |-----------------------------------------
; */                                              // Initialize I2C buffers with desired data for PCA9557 slave
;                                                 // The below configuration sets up the PCA9557 port pins   
;   I2cSlaveAddress = I2C_SLAVE_ADDR_PCA9557;     // Address the PCA9557
	mov R4,#56
	ldr R5,LIT_main+84
	strb R4,[R5,#0]
	.dbline 120
;   I2cPacketDataSize = 2;                        // How many bytes from the I2c buffer to send
	mov R4,#2
	ldr R5,LIT_main+88
	strb R4,[R5,#0]
	.dbline 121
;   I2cBuffer[0] = 0x03;                          // Control register value 0x03 selects the configuration register to define I/O port
	mov R4,#3
	ldr R5,LIT_main+92
	strb R4,[R5,#0]
	.dbline 122
;   I2cBuffer[1] = 0xF3;                          // IO-2 and IO-3 are outputs and the rest are inputs (0's outputs, 1's inputs) 
	mov R4,#243
	ldr R5,LIT_main+96
	strb R4,[R5,#0]
	.dbline 123
;   I2cStart(I2C_WRITE);                          // Send out an I2C Start condition for a Write packet
	mov R0,#0
	bl _I2cStart
L3:
	.dbline 124
L4:
	.dbline 124
;   while(I2cPacketInProgress == TRUE);           // Wait here for I2C packet to complete 
	ldr R4,LIT_main+100
	ldrb R4,[R4,#0]
	cmp R4,#1
	beq L3
	.dbline 132
; 
; /*
; |--------------------------------------------------
; | Config I2C PCA9557 Slave device polarity register
; |--------------------------------------------------
; */                                              // Initialize I2C buffers with desired data for PCA9557 slave
;                                                 // The below configuration sets up the PCA9557 polarity inversion register  
;   I2cSlaveAddress = I2C_SLAVE_ADDR_PCA9557;     // Address the PCA9557
	mov R4,#56
	ldr R5,LIT_main+84
	strb R4,[R5,#0]
	.dbline 133
;   I2cPacketDataSize = 2;                        // How many bytes from the I2c buffer to send
	mov R4,#2
	ldr R5,LIT_main+88
	strb R4,[R5,#0]
	.dbline 134
;   I2cBuffer[0] = 0x02;                          // Control register value 0x02 selects the polarity inversion register 
	mov R4,#2
	ldr R5,LIT_main+92
	strb R4,[R5,#0]
	.dbline 135
;   I2cBuffer[1] = 0x00;                          // All polarities match actual logic levels 
	mov R4,#0
	ldr R5,LIT_main+96
	strb R4,[R5,#0]
	.dbline 136
;   I2cStart(I2C_WRITE);                          // Send out an I2C Start condition for a Write packet
	mov R0,#0
	bl _I2cStart
L7:
	.dbline 137
L8:
	.dbline 137
;   while(I2cPacketInProgress == TRUE);           // Wait here for I2C packet to complete 
	ldr R4,LIT_main+100
	ldrb R4,[R4,#0]
	cmp R4,#1
	beq L7
	b L11
L10:
	.dbline 145
; 
; /*
; |----------------------------------------------------
; |     Start of application
; |----------------------------------------------------
; */
;   while(1)                                      // Do this forever
;     {
	.dbline 152
; 
; /*
; |------------------------------------------------
; | Read PCA9557 I2C Slave device's input register
; |------------------------------------------------
; */  
;     PCA9557portValue = ReadPCA9557IoPort();     // Read 8-bit port value from the PCA9557 via I2C
	bl _ReadPCA9557IoPort
	mov R4,R0
	mov R6,R4
	.dbline 159
; 
; /*
; |-----------------------------------------------------------
; | Write to the PCA9557 port based upon the value read above
; |-----------------------------------------------------------
; */ 
; 	  switch(PCA9557portValue & 0xF0)             // Take port value read from PCA9557 and mask off lower nibble
	and R4,R6,#255
	and R7,R4,#240
	cmp R7,#64
	beq L18
	cmp R7,#64
	bgt L22
L21:
	cmp R7,#16
	beq L16
	cmp R7,#16
	blt L13
L23:
	cmp R7,#32
	beq L17
	b L13
L22:
	cmp R7,#128
	beq L19
	cmp R7,#128
	blt L13
L24:
	cmp R7,#240
	beq L20
	b L13
X0:
	.dbline 160
; 			  {                                       // High nibble IO-4 to IO-7 is now what's left in PCA9557portValue
L16:
	.dbline 162
; 			  case (0x10):	                          // Is I0-4 the only one high?
;             {
	.dbline 163
;             WritePCA9557IoPort(0x04);           // Yes, Turn PCA9557 IO-2 LED On
	mov R0,#4
	bl _WritePCA9557IoPort
	.dbline 164
;             GPIO_IOCLR = MICROBOLT_LED;	        // Keep the MicroBolt LED Off
	mov R4,#4194304
	ldr R5,LIT_main+68
	str R4,[R5,#0]
	.dbline 165
;             break;
	b L14
L17:
	.dbline 168
;             }
; 			  case (0x20):	                          // Is I0-5 the only one high?
;             {
	.dbline 169
;             WritePCA9557IoPort(0x08);           // Yes, Turn PCA9557 IO-3 LED On
	mov R0,#8
	bl _WritePCA9557IoPort
	.dbline 170
;             GPIO_IOCLR = MICROBOLT_LED;	        // Keep the MicroBolt LED Off
	mov R4,#4194304
	ldr R5,LIT_main+68
	str R4,[R5,#0]
	.dbline 171
;             break;
	b L14
L18:
	.dbline 174
;             }
; 			  case (0x40):	                          // Is I0-6 the only one high?
;             {
	.dbline 175
;             WritePCA9557IoPort(0x0C);           // Yes, Turn PCA9557 IO-2 & IO-3 LED's On
	mov R0,#12
	bl _WritePCA9557IoPort
	.dbline 176
;             GPIO_IOCLR = MICROBOLT_LED;	        // Keep the MicroBolt LED Off
	mov R4,#4194304
	ldr R5,LIT_main+68
	str R4,[R5,#0]
	.dbline 177
;             break;
	b L14
L19:
	.dbline 180
;             }
; 			  case (0x80):	                          // Is I0-7 the only one high?
;             {
	.dbline 181
;             WritePCA9557IoPort(0x00);           // Yes, Turn PCA9557 IO-2 & IO-3 LED's Off
	mov R0,#0
	bl _WritePCA9557IoPort
	.dbline 182
;             GPIO_IOSET = MICROBOLT_LED;	        // Turn the MicroBolt LED On
	mov R4,#4194304
	ldr R5,LIT_main+104
	str R4,[R5,#0]
	.dbline 183
;             break;
	b L14
L20:
	.dbline 186
;             }
; 			  case (0xF0):	                          // Are I0-4, IO-5, IO-6, and IO-7 all high?
;             {
	.dbline 187
;             WritePCA9557IoPort(0x0C);           // Yes, Turn PCA9557 IO-2 & IO-3 LED's On
	mov R0,#12
	bl _WritePCA9557IoPort
	.dbline 188
;             GPIO_IOSET = MICROBOLT_LED;	        // Turn the MicroBolt LED On
	mov R4,#4194304
	ldr R5,LIT_main+104
	str R4,[R5,#0]
	.dbline 189
;             break;
	b L14
L13:
	.dbline 192
;             }
; 			  default:                                // Any other combination of IO-4 through IO-7 ends up here
; 					  {
	.dbline 193
;             WritePCA9557IoPort(0x00);           // Turn PCA9557 IO-2 & IO-3 LED's Off
	mov R0,#0
	bl _WritePCA9557IoPort
	.dbline 194
;             GPIO_IOCLR = MICROBOLT_LED;         // Keep the MicroBolt LED Off
	mov R4,#4194304
	ldr R5,LIT_main+68
	str R4,[R5,#0]
	.dbline 195
; 					  break;
L14:
	.dbline 198
L11:
	.dbline 144
	b L10
X1:
	.dbline -2
L1:
	ldmfd R13!,{R15}
	.dbline 0 ; func end
LIT_main:
	DCD -534790144
	DCD -534790140
	DCD -534790012
	DCD -534790016
	DCD -534790004
	DCD -534789888
	DCD _pll_isr
	DCD -3840
	DCD -3584
	DCD -4080
	DCD _I2c_ISR
	DCD -3836
	DCD -3580
	DCD -536690688
	DCD 1430257664
	DCD -536690684
	DCD -536707064
	DCD -536707060
	DCD -536756208
	DCD -536756204
	DCD -536756224
	DCD _I2cSlaveAddress
	DCD _I2cPacketDataSize
	DCD _I2cBuffer
	DCD _I2cBuffer+1
	DCD _I2cPacketInProgress
	DCD -536707068
	.dbsym r PCA9557portValue 6 c
	.dbend
	EXPORT _WritePCA9557IoPort
	.dbfunc e WritePCA9557IoPort _WritePCA9557IoPort fV
	AREA	"C$$code", CODE, READONLY
	ALIGN 4
; IoPortPinValue -> R6
_WritePCA9557IoPort:
	mov R12,R13
	stmfd R13!,{R4,R5,R6,R11,R12,R14}
	mov R11,R13
	mov R6,R0
	.dbline -1
	.dbline 211
; 					  }
;         }
;     }
;   }
; 
; /*
; |------------------------------------------------------------------------------------------
; |     Function        :   WritePCA9557IoPort
; |     Inputs          :   IoPortPinValue
; |     Outputs         :   None
; |     Purpose         :   Write an 8 bit value to the PCA9557 IO port
; |     Author			    :   Micromint, Inc.
; |------------------------------------------------------------------------------------------
; */
; void WritePCA9557IoPort(unsigned char IoPortPinValue)
;   {
	.dbline 212
;   I2cSlaveAddress = I2C_SLAVE_ADDR_PCA9557;     // Address the PCA9557
	mov R4,#56
	ldr R5,LIT_WritePCA9557IoPort+0
	strb R4,[R5,#0]
	.dbline 213
;   I2cPacketDataSize = 2;                        // How many bytes from the I2c buffer to send
	mov R4,#2
	ldr R5,LIT_WritePCA9557IoPort+4
	strb R4,[R5,#0]
	.dbline 214
;   I2cBuffer[0] = 0x01;                          // Control register value 0x01 selects the output register 
	mov R4,#1
	ldr R5,LIT_WritePCA9557IoPort+8
	strb R4,[R5,#0]
	.dbline 215
;   I2cBuffer[1] = IoPortPinValue;                // Desired IO port value 
	ldr R4,LIT_WritePCA9557IoPort+12
	strb R6,[R4,#0]
	.dbline 216
;   I2cStart(I2C_WRITE);                          // Send out an I2C Start condition for a Write packet
	mov R0,#0
	bl _I2cStart
L27:
	.dbline 217
L28:
	.dbline 217
;   while(I2cPacketInProgress == TRUE);           // Wait here for I2C packet to complete
	ldr R4,LIT_WritePCA9557IoPort+16
	ldrb R4,[R4,#0]
	cmp R4,#1
	beq L27
	.dbline -2
L25:
	ldmfd R11,{R4,R5,R6,R11,SP,PC}
	.dbline 0 ; func end
LIT_WritePCA9557IoPort:
	DCD _I2cSlaveAddress
	DCD _I2cPacketDataSize
	DCD _I2cBuffer
	DCD _I2cBuffer+1
	DCD _I2cPacketInProgress
	.dbsym r IoPortPinValue 6 c
	.dbend
	EXPORT _ReadPCA9557IoPort
	.dbfunc e ReadPCA9557IoPort _ReadPCA9557IoPort fc
	AREA	"C$$code", CODE, READONLY
	ALIGN 4
_ReadPCA9557IoPort:
	mov R12,R13
	stmfd R13!,{R4,R5,R11,R12,R14}
	mov R11,R13
	.dbline -1
	.dbline 230
;   }
; 
; /*
; |------------------------------------------------------------------------------------------
; |     Function        :   ReadPCA9557IoPort
; |     Inputs          :   None
; |     Outputs         :   PCA9557 8-bit port value
; |     Purpose         :   Read an 8 bit value from the PCA9557 IO port
; |     Author			    :   Micromint, Inc.
; |------------------------------------------------------------------------------------------
; */
; unsigned char ReadPCA9557IoPort(void)
;   {
	.dbline 231
;   I2cSlaveAddress = I2C_SLAVE_ADDR_PCA9557;     // Address the PCA9557
	mov R4,#56
	ldr R5,LIT_ReadPCA9557IoPort+0
	strb R4,[R5,#0]
	.dbline 232
;   I2cPacketDataSize = 1;                        // How many bytes from the I2c buffer to send
	mov R4,#1
	ldr R5,LIT_ReadPCA9557IoPort+4
	strb R4,[R5,#0]
	.dbline 233
;   I2cBuffer[0] = 0x00;                          // Control register value 0x00 selects input register for reading port pins 
	mov R4,#0
	ldr R5,LIT_ReadPCA9557IoPort+8
	strb R4,[R5,#0]
	.dbline 234
;   I2cStart(I2C_WRITE);                          // Send out an I2C Start condition for a Write packet
	mov R0,#0
	bl _I2cStart
L31:
	.dbline 235
L32:
	.dbline 235
;   while(I2cPacketInProgress == TRUE);           // Wait here for previous I2C packet to complete 
	ldr R4,LIT_ReadPCA9557IoPort+12
	ldrb R4,[R4,#0]
	cmp R4,#1
	beq L31
	.dbline 237
; 
;   I2cSlaveAddress = I2C_SLAVE_ADDR_PCA9557;     // Address the PCA9557
	mov R4,#56
	ldr R5,LIT_ReadPCA9557IoPort+0
	strb R4,[R5,#0]
	.dbline 238
;   I2cPacketDataSize = 1;                        // How many bytes from the I2c buffer to receive
	mov R4,#1
	ldr R5,LIT_ReadPCA9557IoPort+4
	strb R4,[R5,#0]
	.dbline 239
;   I2cStart(I2C_READ);                           // Send out an I2C Start condition for a Read packet 
	mov R0,#1
	bl _I2cStart
L34:
	.dbline 240
L35:
	.dbline 240
;   while(I2cPacketInProgress == TRUE);           // Wait here for previous I2C packet to complete 
	ldr R4,LIT_ReadPCA9557IoPort+12
	ldrb R4,[R4,#0]
	cmp R4,#1
	beq L34
	.dbline 242
; 
;   return(I2cBuffer[0]);                         // Return the byte read from the PCA9557 IO port
	ldr R4,LIT_ReadPCA9557IoPort+8
	ldrb R0,[R4,#0]
	.dbline -2
L30:
	ldmfd R11,{R4,R5,R11,SP,PC}
	.dbline 0 ; func end
LIT_ReadPCA9557IoPort:
	DCD _I2cSlaveAddress
	DCD _I2cPacketDataSize
	DCD _I2cBuffer
	DCD _I2cPacketInProgress
	.dbend
	EXPORT _I2c_ISR
	.dbfunc e I2c_ISR _I2c_ISR fV
	AREA	"C$$code", CODE, READONLY
	ALIGN 4
_I2c_ISR:
	sub R14,R14,#4
	stmfd R13!,{R0,R1,R2,R3,R4,R5,R6,R7,R11,R12,R14}
	mov R11,R13
	.dbline -1
	.dbline 257
;   }
; 
; /*
; |------------------------------------------------------------------------------------------
; |     Function        :   I2c_ISR
; |     Inputs          :   None
; |     Outputs         :   None
; |     Purpose         :   I2C interrupt and command processing
; |     Author          :   Micromint, Inc.
; |------------------------------------------------------------------------------------------
; */
; #pragma interrupt_handler I2c_ISR
; 
; void I2c_ISR(void)
; {
	.dbline 258
; 	switch(I2C_I2STAT)
	ldr R4,LIT_I2c_ISR+0
	ldr R7,[R4,#0]
	cmp R7,#48
	beq L48
	cmp R7,#48
	bgt L59
L58:
	cmp R7,#24
	beq L43
	cmp R7,#24
	bgt L61
L60:
	cmp R7,#8
	beq L41
	cmp R7,#8
	blt L38
L62:
	mov R4,R7
	cmp R4,#16
	beq L42
	b L38
L61:
	cmp R7,#32
	beq L47
	cmp R7,#32
	blt L38
L63:
	mov R4,R7
	cmp R4,#40
	beq L44
	b L38
L59:
	cmp R7,#72
	beq L56
	cmp R7,#72
	bgt L65
L64:
	cmp R7,#56
	beq L49
	cmp R7,#56
	blt L38
L66:
	mov R4,R7
	cmp R4,#64
	beq L50
	b L38
L65:
	cmp R7,#80
	beq L53
	cmp R7,#80
	blt L38
L67:
	mov R4,R7
	cmp R4,#88
	beq L57
	b L38
X2:
	.dbline 259
; 			{
L41:
	.dbline 264
; //****************************************************
; // I2C Master Transmit Service Routines
; //****************************************************
; 			case (0x08):																									// START condition transmitted
; 					{
	.dbline 265
; 					I2cBufferIndex = 0;																			  // Reset index counter
	mov R4,#0
	ldr R5,LIT_I2c_ISR+4
	strb R4,[R5,#0]
	.dbline 266
;           I2C_I2DAT = I2cSlaveAddress | I2cPacketType;              // Desired slave address into I2C register OR'd with Read or Write
	ldr R4,LIT_I2c_ISR+8
	ldrb R4,[R4,#0]
	ldr R5,LIT_I2c_ISR+12
	ldrb R5,[R5,#0]
	orr R4,R5,R4
	ldr R5,LIT_I2c_ISR+16
	str R4,[R5,#0]
	.dbline 267
;       	  I2C_I2CONCLR = I2C_STOP_BIT;	                            // Clear stop bit per datasheet
	mov R4,#16
	ldr R5,LIT_I2c_ISR+20
	str R4,[R5,#0]
	.dbline 268
; 					break;
	b L39
L42:
	.dbline 272
; 					}
; //------------------------------------
; 			case (0x10):																									// Repeated START condition transmitted
; 					{
	.dbline 273
; 					I2cBufferIndex = 0;																			  // Reset index counter
	mov R4,#0
	ldr R5,LIT_I2c_ISR+4
	strb R4,[R5,#0]
	.dbline 274
;           I2C_I2DAT = I2cSlaveAddress | I2cPacketType;              // Desired slave address into I2C register OR'd with Read or Write
	ldr R4,LIT_I2c_ISR+8
	ldrb R4,[R4,#0]
	ldr R5,LIT_I2c_ISR+12
	ldrb R5,[R5,#0]
	orr R4,R5,R4
	ldr R5,LIT_I2c_ISR+16
	str R4,[R5,#0]
	.dbline 275
;       	  I2C_I2CONCLR = I2C_STOP_BIT;	                            // Clear stop bit per datasheet
	mov R4,#16
	ldr R5,LIT_I2c_ISR+20
	str R4,[R5,#0]
	.dbline 276
; 					break;
	b L39
L43:
	.dbline 280
; 					}
; //------------------------------------
; 			case (0x18):																									// Slave address with WRITE transmitted and ACK received
; 					{
	.dbline 281
;           I2C_I2DAT = I2cBuffer[I2cBufferIndex];                    // Put data from I2c buffer into I2C register for sending 
	ldr R4,LIT_I2c_ISR+24
	ldr R5,LIT_I2c_ISR+4
	ldrb R5,[R5,#0]
	ldrb R4,[R5,+R4]
	ldr R5,LIT_I2c_ISR+16
	str R4,[R5,#0]
	.dbline 282
;           I2cBufferIndex++;                                         // Increment the buffer index
	ldr R4,LIT_I2c_ISR+4
	ldrb R5,[R4,#0]
	add R5,R5,#1
	strb R5,[R4,#0]
	.dbline 283
;       	  I2C_I2CONCLR = I2C_START_BIT | I2C_STOP_BIT;		          // Clear start and stop bits per datasheet        
	mov R4,#48
	ldr R5,LIT_I2c_ISR+20
	str R4,[R5,#0]
	.dbline 284
;   				break;
	b L39
L44:
	.dbline 288
; 					}
; //------------------------------------
; 			case (0x28):																									// Data byte transmitted and ACK received
; 					{
	.dbline 289
;           I2C_I2DAT = I2cBuffer[I2cBufferIndex];                    // Put data from I2c buffer into I2C register for sending  
	ldr R4,LIT_I2c_ISR+24
	ldr R5,LIT_I2c_ISR+4
	ldrb R5,[R5,#0]
	ldrb R4,[R5,+R4]
	ldr R5,LIT_I2c_ISR+16
	str R4,[R5,#0]
	.dbline 290
;           I2cBufferIndex++;                                         // Increment the buffer index
	ldr R4,LIT_I2c_ISR+4
	ldrb R5,[R4,#0]
	add R5,R5,#1
	strb R5,[R4,#0]
	.dbline 291
;       	  I2C_I2CONCLR = I2C_START_BIT | I2C_STOP_BIT;		          // Clear start and stop bits per datasheet  
	mov R4,#48
	ldr R5,LIT_I2c_ISR+20
	str R4,[R5,#0]
	.dbline 293
; 
;           if (I2cBufferIndex > I2cPacketDataSize)                   // All the bytes from the I2C buffer sent out?
	ldr R4,LIT_I2c_ISR+28
	ldrb R4,[R4,#0]
	ldr R5,LIT_I2c_ISR+4
	ldrb R5,[R5,#0]
	cmp R5,R4
	ble L39
	.dbline 294
;       	      {
	.dbline 295
;               I2C_I2CONCLR = I2C_START_BIT;                         // Yes, Clear start bit per datasheet  
	mov R4,#32
	ldr R5,LIT_I2c_ISR+20
	str R4,[R5,#0]
	.dbline 296
;               I2cStop();                                            // Done sending data, send a stop condition to end packet
	bl _I2cStop
	.dbline 297
;               }
	.dbline 298
; 					break;
	b L39
L47:
	.dbline 302
; 					}
; //------------------------------------
; 			case (0x20):																									// Slave address transmitted and NAK received
; 					{
	.dbline 303
;           I2C_I2CONCLR = I2C_START_BIT;                             // Clear start bit per datasheet  
	mov R4,#32
	ldr R5,LIT_I2c_ISR+20
	str R4,[R5,#0]
	.dbline 304
;           I2cStop();                                                // Done sending data, send a stop condition to end packet
	bl _I2cStop
	.dbline 305
; 					break;
	b L39
L48:
	.dbline 309
; 					}
; //------------------------------------
; 			case (0x30):																									// Data byte transmitted and NAK received
; 					{
	.dbline 310
;           I2C_I2CONCLR = I2C_START_BIT;                             // Clear start bit per datasheet  
	mov R4,#32
	ldr R5,LIT_I2c_ISR+20
	str R4,[R5,#0]
	.dbline 311
;           I2cStop();                                                // Done sending data, send a stop condition to end packet
	bl _I2cStop
	.dbline 312
; 					break;
	b L39
L49:
	.dbline 316
; 					}
; //------------------------------------
; 			case (0x38):																									// Master lost arbitration 
; 					{                                                         // Could send another START if desirable
	.dbline 317
;       	  I2C_I2CONCLR = I2C_START_BIT | I2C_STOP_BIT;		          // Clear start and stop bits per datasheet 
	mov R4,#48
	ldr R5,LIT_I2c_ISR+20
	str R4,[R5,#0]
	.dbline 318
; 					break;
	b L39
L50:
	.dbline 326
; 					}
; //------------------------------------
; 
; //****************************************************
; // I2C Master Receive Service Routines
; //****************************************************
; 			case (0x40):																									// Slave address with READ transmitted and ACK received
; 					{
	.dbline 327
; 					if (I2cPacketDataSize <= 1)		                            // Only one byte for the packet?
	ldr R4,LIT_I2c_ISR+28
	ldrb R4,[R4,#0]
	cmp R4,#1
	bgt L51
	.dbline 328
; 					    {
	.dbline 329
; 	            I2C_I2CONCLR = I2C_AA_BIT;                            // Send a NAK, don't want any more bytes
	mov R4,#4
	ldr R5,LIT_I2c_ISR+20
	str R4,[R5,#0]
	.dbline 330
; 							I2cBufferIndex = 0;													          // Reset count index
	mov R4,#0
	ldr R5,LIT_I2c_ISR+4
	strb R4,[R5,#0]
	.dbline 331
; 							}
	b L52
L51:
	.dbline 333
; 					else
; 							{
	.dbline 334
; 	            I2C_I2CONSET |= I2C_AA_BIT;                           // Send an ACK
	ldr R4,LIT_I2c_ISR+32
	ldr R5,[R4,#0]
	orr R5,R5,#4
	str R5,[R4,#0]
	.dbline 335
; 						  }
L52:
	.dbline 337
; 
;       	  I2C_I2CONCLR = I2C_START_BIT | I2C_STOP_BIT;		          // Clear start and stop bits per datasheet            
	mov R4,#48
	ldr R5,LIT_I2c_ISR+20
	str R4,[R5,#0]
	.dbline 338
; 					break;
	b L39
L53:
	.dbline 342
; 					}
; //------------------------------------
; 			case (0x50):																									// Data byte received and ACK returned
; 					{                                                         
	.dbline 343
; 					I2cBuffer[I2cBufferIndex] = I2C_I2DAT;									  // Grab the I2C data and put it into the I2C buffer
	ldr R4,LIT_I2c_ISR+4
	ldrb R4,[R4,#0]
	ldr R5,LIT_I2c_ISR+24
	ldr R6,LIT_I2c_ISR+16
	ldr R6,[R6,#0]
	strb R6,[R4,+R5]
	.dbline 344
;           I2cBufferIndex++;																          // Increment buffer count index
	ldr R4,LIT_I2c_ISR+4
	ldrb R5,[R4,#0]
	add R5,R5,#1
	strb R5,[R4,#0]
	.dbline 345
; 					if (I2cBufferIndex < (I2cPacketDataSize - 1))             // Still more data to come for packet?
	ldr R4,LIT_I2c_ISR+28
	ldrb R4,[R4,#0]
	sub R4,R4,#1
	ldr R5,LIT_I2c_ISR+4
	ldrb R5,[R5,#0]
	cmp R5,R4
	bge L54
	.dbline 346
; 					    {
	.dbline 347
; 	            I2C_I2CONSET |= I2C_AA_BIT;                           // Yes, Send an ACK
	ldr R4,LIT_I2c_ISR+32
	ldr R5,[R4,#0]
	orr R5,R5,#4
	str R5,[R4,#0]
	.dbline 348
; 							}
	b L55
L54:
	.dbline 350
; 					else
; 							{
	.dbline 351
; 	            I2C_I2CONCLR = I2C_AA_BIT;                            // No, Send a NAK, don't want any more bytes
	mov R4,#4
	ldr R5,LIT_I2c_ISR+20
	str R4,[R5,#0]
	.dbline 352
; 							I2cBufferIndex = 0;													          // Reset count index
	mov R4,#0
	ldr R5,LIT_I2c_ISR+4
	strb R4,[R5,#0]
	.dbline 353
; 						  }
L55:
	.dbline 355
; 
;       	  I2C_I2CONCLR = I2C_START_BIT | I2C_STOP_BIT;		          // Clear start and stop bits per datasheet 
	mov R4,#48
	ldr R5,LIT_I2c_ISR+20
	str R4,[R5,#0]
	.dbline 356
; 					break;
	b L39
L56:
	.dbline 360
; 					}
; //------------------------------------
; 			case (0x48):																									// Slave address with READ transmitted and NAK received
; 					{
	.dbline 361
;           I2C_I2CONCLR = I2C_START_BIT;                             // Clear start bit per datasheet  
	mov R4,#32
	ldr R5,LIT_I2c_ISR+20
	str R4,[R5,#0]
	.dbline 362
;           I2cStop();                                                // Send a stop condition to end packet
	bl _I2cStop
	.dbline 363
; 					break;
	b L39
L57:
	.dbline 367
; 					}
; //------------------------------------
; 			case (0x58):																									// Data byte received and NAK returned
; 					{           
	.dbline 368
; 					I2cBuffer[I2cBufferIndex] = I2C_I2DAT;									  // Grab the I2C data and put it into the I2C buffer                                              
	ldr R4,LIT_I2c_ISR+4
	ldrb R4,[R4,#0]
	ldr R5,LIT_I2c_ISR+24
	ldr R6,LIT_I2c_ISR+16
	ldr R6,[R6,#0]
	strb R6,[R4,+R5]
	.dbline 369
;           I2C_I2CONCLR = I2C_START_BIT;                             // Clear start bit per datasheet  
	mov R4,#32
	ldr R5,LIT_I2c_ISR+20
	str R4,[R5,#0]
	.dbline 370
;           I2cStop();                                                // Send a stop condition to end packet
	bl _I2cStop
	.dbline 371
; 					break;
	b L39
L38:
	.dbline 375
; 					}
; //------------------------------------
; 			default:
; 					{
	.dbline 376
;       	  I2C_I2CONCLR = I2C_START_BIT | I2C_STOP_BIT;		          // Clear start and stop bits per datasheet 
	mov R4,#48
	ldr R5,LIT_I2c_ISR+20
	str R4,[R5,#0]
	.dbline 377
; 					break;
L39:
	.dbline 382
; 					}
; 			}
; //------------------------------------
; 
; 	I2C_I2CONCLR = I2C_SI_BIT;																		    // Clear I2C SI interrupt flag 
	mov R4,#8
	ldr R5,LIT_I2c_ISR+20
	str R4,[R5,#0]
	.dbline 383
; 	VICVectAddr = VIC_ACK; 																						// Acknowledge Interrupt
	mov R4,#0
	ldr R5,LIT_I2c_ISR+36
	str R4,[R5,#0]
	.dbline -2
L37:
	ldmfd R13!,{R0,R1,R2,R3,R4,R5,R6,R7,R11,R12,PC}^
	.dbline 0 ; func end
LIT_I2c_ISR:
	DCD -536756220
	DCD _I2cBufferIndex
	DCD _I2cPacketType
	DCD _I2cSlaveAddress
	DCD -536756216
	DCD -536756200
	DCD _I2cBuffer
	DCD _I2cPacketDataSize
	DCD -536756224
	DCD -4048
	.dbend
	EXPORT _I2cStart
	.dbfunc e I2cStart _I2cStart fV
	AREA	"C$$code", CODE, READONLY
	ALIGN 4
; I2cReadOrWriteNot -> R4
_I2cStart:
	mov R12,R13
	stmfd R13!,{R4,R12,R14}
	mov R4,R0
	.dbline -1
	.dbline 396
; }
; 
; /*
; |------------------------------------------------------------------------------------------
; |     Function        :   I2cStart
; |     Inputs          :   I2cReadOrWriteNot
; |     Outputs         :   None
; |     Purpose         :   Send a start condition and setup packet type (Read or Write)
; |     Author			    :   Micromint, Inc.
; |------------------------------------------------------------------------------------------
; */
; void I2cStart(unsigned char I2cReadOrWriteNot)
;   {
	.dbline 397
;   I2cPacketInProgress = TRUE;                   // Flag for stating an I2C packet is about to happen
	mov R0,#1
	ldr R1,LIT_I2cStart+0
	strb R0,[R1,#0]
	.dbline 398
;   I2cPacketType = I2cReadOrWriteNot;            // Flag for stating what kind of packet it is; Read or Write
	ldr R0,LIT_I2cStart+4
	strb R4,[R0,#0]
	.dbline 399
; 	I2C_I2CONSET |= I2C_START_BIT;                // Set the start bit 
	ldr R0,LIT_I2cStart+8
	ldr R1,[R0,#0]
	orr R1,R1,#32
	str R1,[R0,#0]
	.dbline -2
L68:
	ldmfd R13!,{R4,SP,PC}
	.dbline 0 ; func end
LIT_I2cStart:
	DCD _I2cPacketInProgress
	DCD _I2cPacketType
	DCD -536756224
	.dbsym r I2cReadOrWriteNot 4 c
	.dbend
	EXPORT _I2cStop
	.dbfunc e I2cStop _I2cStop fV
	AREA	"C$$code", CODE, READONLY
	ALIGN 4
_I2cStop:
	.dbline -1
	.dbline 412
;   }
; 
; /*
; |------------------------------------------------------------------------------------------
; |     Function        :   I2cStop
; |     Inputs          :   None
; |     Outputs         :   None
; |     Purpose         :   Send a stop condition
; |     Author			    :   Micromint, Inc.
; |------------------------------------------------------------------------------------------
; */
; void I2cStop(void)
;   {
	.dbline 413
; 	I2C_I2CONSET |= I2C_STOP_BIT;                 // Set the stop bit 
	ldr R0,LIT_I2cStop+0
	ldr R1,[R0,#0]
	orr R1,R1,#16
	str R1,[R0,#0]
	.dbline 414
;   I2cPacketInProgress = FALSE;                  // Flag for stating I2C packet is done
	mov R0,#0
	ldr R1,LIT_I2cStop+4
	strb R0,[R1,#0]
	.dbline -2
L69:
	mov R15,R14
	.dbline 0 ; func end
LIT_I2cStop:
	DCD -536756224
	DCD _I2cPacketInProgress
	.dbend
	EXPORT _pll_isr
	.dbfunc e pll_isr _pll_isr fV
	AREA	"C$$code", CODE, READONLY
	ALIGN 4
_pll_isr:
	sub R14,R14,#4
	stmfd R13!,{R0,R1,R11,R12,R14}
	mov R11,R13
	.dbline -1
	.dbline 429
;   }
; 
; /*
; |------------------------------------------------------------------------------------------
; |     Function        :   pll_isr
; |     Inputs          :   None
; |     Outputs         :   None
; |     Purpose         :   Once PLL has locked, connect it and use for system clock
; |     Author			    :   Micromint, Inc.
; |------------------------------------------------------------------------------------------
; */
; #pragma interrupt_handler pll_isr
; 
; void pll_isr(void)
;   {
	.dbline 430
;   SCB_PLLCON |= 0x02;                           // Connect the PLL 
	ldr R0,LIT_pll_isr+0
	ldr R1,[R0,#0]
	orr R1,R1,#2
	str R1,[R0,#0]
	.dbline 431
;   SCB_PLLFEED = 0xAA;					   	  	          // Shadow register copy to enable changes
	mov R0,#170
	ldr R1,LIT_pll_isr+4
	str R0,[R1,#0]
	.dbline 432
;   SCB_PLLFEED = 0x55;                           // in PLLCON and PLLCFG
	mov R0,#85
	ldr R1,LIT_pll_isr+4
	str R0,[R1,#0]
	.dbline 433
;   VICIntEnClear = PLL_CLR;                      // Clear PLL interrupt flag
	mov R0,#4096
	ldr R1,LIT_pll_isr+8
	str R0,[R1,#0]
	.dbline 434
;   VICVectAddr = VIC_ACK;                        // Acknowledge Interrupt
	mov R0,#0
	ldr R1,LIT_pll_isr+12
	str R0,[R1,#0]
	.dbline -2
L70:
	ldmfd R13!,{R0,R1,R11,R12,PC}^
	.dbline 0 ; func end
LIT_pll_isr:
	DCD -534790016
	DCD -534790004
	DCD -4076
	DCD -4048
	.dbend
	AREA	"Cudata", NOINIT
_I2cBuffer:
	SPACE 20
	.dbsym s I2cBuffer _I2cBuffer A[20:20]c
	END
